#!/bin/tcsh -f
###################################################
# Change the next line according to your settings.
###################################################
set UNRES = /people2/adam/PROTARCH/UNRES/bin/unres.csh
##########################################################################
# Simple minimization run - Ac-Ala19-NHMe starting from an "ideal" helical
# conformation.
##########################################################################
${UNRES} LJ ala19
diff ala19.out_LJ OUTPUTS/. > ala19.diff
###################################################################
# Regularization run of proteinA, starting from the NMR structure.
###################################################################
${UNRES} LJ prota
diff prota.out_LJ OUTPUTS/. > prota.diff
