      subroutine make_array
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.CSA'

ccccccccccccccccccccccccc
c Level-2: group
ccccccccccccccccccccccccc

      indg=0
      do k=1,numch
ccccccccccccccccccccccccccccccccccccccccc
! Groups the THETAs and the GAMMAs
       do j=2,nres-1
         indg=indg+1
         if (j.lt.nres-1) then
           ngroup(indg)=2
         else
           ngroup(indg)=1
         endif
         do i=1,ngroup(indg)
          igroup(1,i,indg)=i
          igroup(2,i,indg)=j
          igroup(3,i,indg)=k
         enddo
       enddo
ccccccccccccccccccccccccccccccccccccccccc
      enddo
! Groups the ALPHAs and the BETAs
      do k=1,numch
       do j=2,nres-1
        if(itype(j).ne.10) then
         indg=indg+1
         ngroup(indg)=2
         do i=1,ngroup(indg)
          igroup(1,i,indg)=i+2
          igroup(2,i,indg)=j
          igroup(3,i,indg)=k
         enddo
        endif
       enddo
      enddo

      ntotgr=indg
      write(iout,*) 
      write(iout,*) "# of groups: ",ntotgr
      do i=1,ntotgr
       write(iout,41) i,ngroup(i),((igroup(k,j,i),k=1,3),j=1,ngroup(i))
      enddo
!      close(iout)

   40 format(i3,3x,3i3)
   41 format(2i3,3x,6(3i3,2x))

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine make_ranvar(n,idum)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.BANK'
      m=0
      print *,'HOHOHOHO Make_RanVar!!!!!'
      itrial=0
      do while(m.lt.n .and. itrial.le.10000)
        itrial=itrial+1
        jeden=1
        call gen_rand_conf(jeden,*10)
c       call intout
        m=m+1
        do j=2,nres-1
          dihang_in(1,j,1,m)=theta(j+1)
          dihang_in(2,j,1,m)=phi(j+2)
          dihang_in(3,j,1,m)=alph(j)
          dihang_in(4,j,1,m)=omeg(j)
        enddo  
        dihang_in(2,nres-1,1,m)=0.0d0
        goto 20
  10    write (iout,*) 'Failed to generate conformation #',m+1,
     &   ' itrial=',itrial
  20    continue
      enddo
      print *,'Make_RanVar!!!!! m=',m,' itrial=',itrial

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccc
