      SUBROUTINE CLUSTER(NCON,PRINTANG,PRINTPDB,printmol2)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      LOGICAL PRINTANG(max_cut)
      integer PRINTPDB(max_cut),printmol2(max_cut)
      include 'COMMON.CLUSTER'
      include 'COMMON.IOUNITS'

c      ICANT(I,J)=((NCON+NCON-J)*(J-1))/2+I-J

      print '(a)','in CLUSTER'

      do i=1,ncut
        print *,i,printang(i),printpdb(i)
      enddo

      t1=tcpu()

      WRITE (iout,'(80(1H-))')

      DO ICUT=1,NCUT

      ARBT=RCUTOFF(ICUT)
      print *,'icut',icut,' arbt',arbt
      
      WRITE (iout,*) 
      WRITE (iout,'(a,f10.5)') 'AT CUTOFF:',ARBT
*
*--- Sort conformations according to rms; the final ordering is stored in icc
*
      DO 111 I=1,NCON
  111 ICC(I)=I
      ISTART=1
      IGR=1   
      IF (NCON.LT.2) THEN
        WRITE (iout,'(a)') 'Too few conformations to cluster'
        RETURN
      ENDIF
   15 ICG=2
      ODLEGLOSC=10000.0
      DO 30 I=ISTART,NCON
      DO 31 J=I+1,NCON
      IF (ICC(I).GT.ICC(J)) THEN
        ODL=ATTALUMS(ICANT(ICC(I),ICC(J)))
      ELSE
        ODL=ATTALUMS(ICANT(ICC(J),ICC(I)))
      ENDIF
      IF (ODL.LT.ODLEGLOSC) THEN
        IC1=I
        IC2=J
        ODLEGLOSC=ODL
      ENDIF
   31 CONTINUE
   30 CONTINUE
      IF (ODLEGLOSC.LT.ARBT) THEN
        ICS=ICC(ISTART)
        ICC(ISTART)=ICC(IC1)
        ICC(IC1)=ICS
        ICS=ICC(ISTART+1)
        ICC(ISTART+1)=ICC(IC2)
        ICC(IC2)=ICS
        NCONF(IGR,1)=ISTART
        NCONF(IGR,2)=ISTART+1
        ISTART=ISTART+2
cd      write (iout,*) '1: igr',igr,' istart',istart
      ELSE
        NGR=IGR+NCON-ISTART
        DO 41 IIG=IGR,NGR
          NCONF(IIG,1)=ISTART+IIG-IGR
   41     LICZ(IIG)=1
        GOTO 42 
      ENDIF
   24 ODL1=10000.0
      DO 32 I=ISTART,NCON
C     DO 33 J=1,ICG-1
      DO 33 J=1,ICG
      IF (ICC(I).GT.ICC(NCONF(IGR,J))) THEN
        ODL=ATTALUMS(ICANT(ICC(I),ICC(NCONF(IGR,J))))
      ELSE
        ODL=ATTALUMS(ICANT(ICC(NCONF(IGR,J)),ICC(I)))
      ENDIF
      IF (ODL.LT.ODL1) THEN
        IC1=I
        IC2=NCONF(IGR,J)
        ODL1=ODL
      ENDIF
   33 CONTINUE
   32 CONTINUE 
      IF (ODL1.LT.ARBT) THEN
        ICG=ICG+1 
        ICS=ICC(ISTART)
        ICC(ISTART)=ICC(IC1)
        ICC(IC1)=ICS
        NCONF(IGR,ICG)=ISTART
        ISTART=ISTART+1
        IF (ISTART.LE.NCON) THEN
          GOTO 24
        ELSE
          LICZ(IGR)=ICG
        ENDIF
      ELSE
        LICZ(IGR)=ICG
cd      write (iout,*) '2: igr',igr,' istart',istart
        IF (ISTART.LE.NCON) THEN
          IGR=IGR+1
          GOTO 15
        ENDIF
      END IF
      NGR=IGR
   42 DO I=1,NGR
        DO J=1,LICZ(I)
          NCONF(I,J)=ICC(NCONF(I,J))
        ENDDO
      ENDDO
C
C  SORT CONFORMATIONS IN GROUPS ACC. TO ENERGY
C
      CALL SRTCLUST
      if (plot_tree) CALL TRACK(ICUT)
      CALL WRTCLUST(NCON,ICUT,PRINTANG,PRINTPDB,printmol2)

      t2=tcpu()

      write (iout,'(/a,1pe14.5,a/)') 
     &  'Time for partitioning:',T2-T1,' sec.'

      t1=tcpu()

      WRITE (iout,'(80(1H-))')

      IF (LGRP) CALL PRP(NCON)

      ENDDO   

      if (plot_tree) then
        CALL WRITRACK
        CALL PLOTREE
      endif

      END

