      SUBROUTINE CLUSTMAZ(NCON,PRINTANG,PRINTPDB,printmol2)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      include 'COMMON.CLUSTER'
      include 'COMMON.IOUNITS'
      LOGICAL PRINTANG(max_cut)
      integer PRINTPDB(max_cut),printmol2(max_cut)

      print *,'in CLUSTER'

      t1=tcpu()

      CALL DRZEWO(iout,NCON)

      t2=tcpu()

      write (iout,*)
      write (iout,'(a,1pe15.5,a)') 
     & 'TIME FOR MINIMAL-TREE CONSTRUCTION:',T2-T1,' SEC.'
      write (iout,*)

      t1=tcpu()
  
      WRITE (iout,'(/40(1H-))')
      WRITE (iout,'(a)') 'PARTITION OF THE MINIMAL TREE:'
      WRITE (iout,'(40(1H-))')
      WRITE (iout,'(//80(1H-))')

      DO ICUT=1,NCUT

      print *,'icut=',icut,' rcut=',rcutoff(icut)
      CALL PODZIAL(iout,ICUT,NCON)
      CALL SRTCLUST 
      if (plot_tree) CALL TRACK(ICUT)
      CALL WRTCLUST (NCON,ICUT,PRINTANG,PRINTPDB,printmol2)

      t2=tcpu()

      write (iout,*)
      write (iout,'(a,1pe15.5,a)')'TIME FOR PARTITIONING:',T2-T1,' SEC.'
      write (iout,*)

      t1=tcpu()

      IF (LGRP) CALL PRP(NCON)

      WRITE (iout,'(80(1H-))')

      ENDDO   

      if (plot_tree) then
        CALL WRITRACK
        CALL PLOTREE
      endif

      END

