C
C**********************
      SUBROUTINE BANACH(N,A,X)
C**********************
C     Banachiewicz
*     IMPLICIT REAL*8 (A-H,O-Z)
      include 'parcom.dat'
      PARAMETER (NMAX=MAXRES)
      DIMENSION A(NMAX,NMAX),X(NMAX),D(NMAX)
      COMMON /BANII/ D
      D(1)=1./A(1,1)
      DO 80 I=2,N
      A(I,1)=A(1,I)
      DO 81 J=2,I-1
      XX=A(J,I)
      DO 82 K=1,J-1
      XX=XX-A(I,K)*A(J,K)
   82 CONTINUE
      A(I,J)=XX
   81 CONTINUE
      XX=A(I,I)
      JJJJ=I-1
      DO 83 J=1,JJJJ
      AIJ=A(I,J)
      AIJD=AIJ*D(J)
      A(I,J)=AIJD
      XX=XX-AIJ*AIJD
   83 CONTINUE 
      D(I)=1./XX
   80 CONTINUE
C
      CALL BANAII(N,A,X)
      RETURN
      END
C************************
      SUBROUTINE BANAII(N,A,X)
C************************
*     IMPLICIT REAL*8 (A-H,O-Z)
      include 'parcom.dat'
      PARAMETER (NMAX=MAXRES)
      DIMENSION A(NMAX,NMAX),X(NMAX),D(NMAX)
      COMMON /BANII/ D
      DO 90 I=1,N
      Z=X(I)
      JJJJ=I-1
      DO 91 J=JJJJ,1,-1
      Z=Z-A(I,J)*X(J)
   91 CONTINUE
      X(I)=Z
   90 CONTINUE
      DO 92 I=N,1,-1
      Z=X(I)*D(I)
      JJJJ=I+1
      DO 93 J=JJJJ,N
      Z=Z-A(J,I)*X(J)
   93 CONTINUE
      X(I)=Z
   92 CONTINUE
      RETURN
      END
C
      SUBROUTINE MATINVERT(N,A,A1)
      include 'parcom.dat'
      PARAMETER (NMAX=MAXRES)
      DIMENSION A(NMAX,NMAX),A1(NMAX,NMAX),D(NMAX)
      COMMON /BANII/ D
      DIMENSION X(NMAX)
      DO I=1,N
        X(I)=0.0
      ENDDO
      X(1)=1.0
      CALL BANACH(N,A,X)
      DO I=1,N
        A1(I,1)=X(I)
      ENDDO
      DO I=2,N
        DO J=1,N
          X(J)=0.0
        ENDDO
        X(I)=1.0
        CALL BANAII(N,A,X)
        DO J=1,N
          A1(J,I)=X(J)
        ENDDO
      ENDDO
      RETURN
      END

    
